@echo off
setlocal enableDelayedExpansion
pushd "%~dp0"
Set Para=%*
Set ErrorNum=0
if not exist "C:\OEM\AcerLogs" md "C:\OEM\AcerLogs"
Set AcerLog="C:\OEM\AcerLogs\UserAlaunch.log"
if not exist "C:\OEM\AcerLogs\UserAlaunch.log" set AcerLog="%~dp0Setup.log"
Echo. >> %AcerLog%
Echo. >> %AcerLog%
ECHO %DATE% %TIME%[Log START]  ============ %~dpnx0 ============ >> %AcerLog%

if not exist rstCli64.exe (
	Echo %Date% %Time%[Log TRACE]  rstCli64.exe not found, call :ErrorMsg >>%AcerLog%
	Set ErrorNum=1
	call :ErrorMsg
	call :ErrorMsg
	call :ErrorMsg
	goto :END
)

if not exist "C:\OEM\AcerLogs\InstallediRST_rebooted.tag" (
	Echo %Date% %Time%[Log TRACE]  call :InstallDriver>>%AcerLog%
	call :InstallDriver	
) else (
	Echo %Date% %Time%[Log TRACE]  "C:\OEM\AcerLogs\InstallediRST_rebooted.tag" found. checking if need to enable Optane volume.>>%AcerLog%
)

Echo %Date% %Time%[Log TRACE]  Check Optane memory info >>%AcerLog%
Echo %Date% %Time%[Log TRACE]  rstcli64.exe --OptaneMemory --info>>%AcerLog%
rstcli64.exe --OptaneMemory --info>GetOptaneMemoryInfo.txt
Echo %Date% %Time%[Log TRACE]  type GetOptaneMemoryInfo.txt>>%AcerLog%
type GetOptaneMemoryInfo.txt>>%AcerLog%
Echo %Date% %Time%[Log TRACE]  find /i "Platform is Intel Optane ready" GetOptaneMemoryInfo.txt>>%AcerLog% 2>&1
find /i "Platform is Intel Optane ready" GetOptaneMemoryInfo.txt>>%AcerLog% 2>&1
if %errorlevel% neq 0 (
	Echo. >> %AcerLog%
	Echo %Date% %Time%[Log TRACE]  "Platform is Intel Optane ready" not found, no need to setup Optane volume, goto :END>>%AcerLog%
	goto :END
)
Echo %Date% %Time%[Log TRACE]  "Platform is Intel Optane ready" found. >>%AcerLog%


Echo. >> %AcerLog%
Echo. >> %AcerLog%
Echo %Date% %Time%[Log TRACE]  Start to setup Optane volume >>%AcerLog%

Set OSDiskIndex=0
Set OSDiskSerialNumber=None
Set OptaneMemoryDiskIndex=1
Set OptaneMemorySerialNumber=None
Set OSDiskID=Empty
Set OptaneMemoryDiskID=Empty

:GET_OSDISK_SERIALNUMBER
Echo. >> %AcerLog%
Cscript /nologo GetDiskPartIndex.vbs >> %AcerLog% 2>&1
For /f "tokens=1,3,5 delims==- " %%k in ('Cscript /nologo GetDiskPartIndex.vbs') do (
	If %%k equ C: (
		Set OSDiskIndex=%%l
		Echo [!DATE! !TIME!] DiskIndex of OS Partition is !OSDiskIndex! >> %AcerLog%	
	)		
)

Echo.>> %AcerLog%

For /f "skip=1 tokens=1 delims=" %%k in ('wmic diskdrive where index^=%OSDiskIndex% get serialnumber') do (
	Set OSDiskSerialNumber=%%k
	Echo [!DATE! !TIME!] [Origin] OSDiskSerialNumber is "!OSDiskSerialNumber!" >> %AcerLog%
	Echo.>> %AcerLog%
	Echo [!DATE! !TIME!] Remove leading and trailing spaces of OSDiskSerialNumber >> %AcerLog%
	Echo.>> %AcerLog%
	Call :TRIM OSDiskSerialNumber
	Echo [!DATE! !TIME!] [Final] OSDiskSerialNumber is "!OSDiskSerialNumber!" >> %AcerLog%
	goto :GET_OPTANEorTETONMEMORY_DISK_INDEX
)

:GET_OPTANEorTETONMEMORY_DISK_INDEX
Echo [!DATE! !TIME!] Start to detect TetonMemoryIndex >> %AcerLog%
wmic diskdrive where "caption like '%%Intel HBR%%'" get index, size | sort > TetonMemory.txt
Echo.>> %AcerLog%
Set TetonMemory_DiskIndex=99
Set DiskIndex_temp=99
Set TetonMemory_DiskSize=34359738368
Set DiskSize_temp=34359738368

For /f "skip=1 tokens=1,2 delims= " %%i in (TetonMemory.txt) do (
	Set DiskIndex_temp=%%i
	Set DiskSize_temp=%%j	
	For /f "tokens=1 delims= " %%k in ('Cscript /nologo _TetonMemoryCompare.vbs !DiskSize_temp! !TetonMemory_DiskSize!') do (
		Echo [!DATE! !TIME!] _TetonMemoryCompare.vbs return: %%k >> %AcerLog%
		If %%k equ 1 (
			Set TetonMemory_DiskIndex=%%i
			Set TetonMemory_DiskSize=%%j
			Echo [!DATE! !TIME!] TetonMemory Index turn to !TetonMemory_DiskIndex! >> %AcerLog%
			Echo [!DATE! !TIME!] TetonMemory Size turn to !TetonMemory_DiskSize! >> %AcerLog%	
		)		
	)
)
Echo TetonMemory Index is %TetonMemory_DiskIndex%
Echo TetonMemory Size is %TetonMemory_DiskSize%

If %TetonMemory_DiskIndex% neq 99 (
	Set OptaneMemoryDiskIndex=%TetonMemory_DiskIndex%	
	goto :GET_OPTANE_MEMORY_SERIALNUMBER
	)
else (
	Echo [!DATE! !TIME!] Start to detect OptaneMemoryIndex >> %AcerLog%
	wmic diskdrive where "caption like '%%Intel MEM%%'" get index | sort > OptaneMemory.txt
	Echo.>> %AcerLog%
	For /f "skip=1 tokens=1 delims=" %%k in (OptaneMemory.txt) do (
		Set OptaneMemoryDiskIndex=%%k	
		goto :GET_OPTANE_MEMORY_SERIALNUMBER
	)
)

:GET_OPTANE_MEMORY_SERIALNUMBER
Echo.>> %AcerLog%
For /f "skip=1 tokens=1 delims=" %%k in ('wmic diskdrive where index^=%OptaneMemoryDiskIndex% get serialnumber') do (
	Set OptaneMemorySerialNumber=%%k
	Echo [!DATE! !TIME!] [Origin] OptaneMemorySerialNumber is "!OptaneMemorySerialNumber!" >> %AcerLog%
	Echo.>> %AcerLog%
	Echo [!DATE! !TIME!] Remove leading and trailing spaces of OptaneMemorySerialNumber >> %AcerLog%
	Echo.>> %AcerLog%
	Call :TRIM OptaneMemorySerialNumber
	Echo [!DATE! !TIME!] [Final] OptaneMemorySerialNumber is "!OptaneMemorySerialNumber!" >> %AcerLog%
	goto :GET_DISKID_FOR_OSDISK_AND_OPTANEMEMORY
)

:GET_DISKID_FOR_OSDISK_AND_OPTANEMEMORY
Echo.>> %AcerLog%
rstcli64.exe -I --comma > DeviceInfo.txt
type DeviceInfo.txt>>%AcerLog%
For /f "tokens=1 delims=ID:, " %%k in ('type DeviceInfo.txt ^| find "%OSDiskSerialNumber%"') do (
	Set OSDiskID=%%k
	Echo [!DATE! !TIME!] OSDiskID is "!OSDiskID!" >> %AcerLog%
)
For /f "tokens=1 delims=ID:, " %%k in ('type DeviceInfo.txt ^| find "%OptaneMemorySerialNumber%"') do (
	Set OptaneMemoryDiskID=%%k
	Echo [!DATE! !TIME!] OptaneMemoryDiskID is "!OptaneMemoryDiskID!" >> %AcerLog%
)
If %TetonMemory_DiskIndex% neq 99 (
	goto :Check_ACDCmode_forTeton
	)
else (
	goto :CLEAR_METADATA_AND_ENABLE
)

:Check_ACDCmode_forTeton
set OnAC=false
set cmd=WMIC /NameSpace:\\root\WMI Path BatteryStatus Get PowerOnline
%cmd% | find /i "true" > nul && set OnAC=true
if %OnAC% == true (
	ECHO %DATE% %TIME%[Log TRACE] PowerOnline=True >> %AcerLog%
	ECHO %DATE% %TIME%[Log TRACE] Now is AC mode! >> %AcerLog%
) else (
	ECHO %DATE% %TIME%[Log TRACE] PowerOnline=False >> %AcerLog%
	ECHO %DATE% %TIME%[Log TRACE] Now is DC mode because PowerOffline. >> %AcerLog%
		Set ErrorNum=3
		call :ErrorMsg
		goto :Check_ACDCmode_forTeton
)

:CLEAR_METADATA_AND_ENABLE
Echo %Date% %Time%[Log TRACE]  rstcli64.exe -M -Z >>%AcerLog%
rstcli64.exe -M -Z >>%AcerLog% 2>&1
Echo %Date% %Time%[Log TRACE]  errorlevel is %errorlevel% >> %AcerLog%
Echo. >> %AcerLog%
Echo %Date% %Time%[Log TRACE]  rstcli64.exe --OptaneMemory --enable --fast-drive %OptaneMemoryDiskID% --drive-to-accel %OSDiskID% >>%AcerLog%
rstcli64.exe --OptaneMemory --enable --fast-drive %OptaneMemoryDiskID% --drive-to-accel %OSDiskID% >>%AcerLog% 2>&1
Echo %Date% %Time%[Log TRACE]  errorlevel is %errorlevel% >> %AcerLog%
if %errorlevel% neq 0 (
	Echo %Date% %Time%[Log TRACE]  rstCli64.exe enable Optane Fail, call :ErrorMsg >>%AcerLog%
	Set ErrorNum=2
	call :ErrorMsg
	call :ErrorMsg
	call :ErrorMsg
)

:END
setlocal disableDelayedExpansion
Echo. >> %AcerLog%
ECHO %DATE% %TIME%[Log LEAVE]  ============ %~dpnx0 ============ >> %AcerLog%
Echo. >> %AcerLog%
Echo. >> %AcerLog%
Echo. >> %AcerLog%

popd
exit /b 0

:InstallDriver
if exist Install.cmd (
	Echo %Date% %Time%[Log TRACE]  [Start] Install.cmd >>%AcerLog%
	call Install.cmd
	Echo %Date% %Time%[Log TRACE]  [End] Install.cmd >>%AcerLog%
) else (
	Echo %Date% %Time%[Log TRACE]  [Start] SetupRST.exe %Para% >>%AcerLog%
	start /w SetupRST.exe %Para%
	Echo %Date% %Time%[Log TRACE]  [End] SetupRST.exe %Para% >>%AcerLog%
)
:Clear_AlaunchX
(tasklist | find /i "AlaunchX") && (
	ECHO %DATE% %TIME%[Log TRACE]  Clear existed AlaunchX...
	tskill AlaunchX.exe /a /v || taskkill /IM AlaunchX.exe /F
	ECHO %DATE% %TIME%[Log TRACE]  goto Clear_AlaunchX
	goto Clear_AlaunchX
) >>%AcerLog% 2>&1
ECHO %DATE% %TIME%[Log TRACE]  shutdown /r /t 10>"C:\OEM\AcerLogs\InstallediRST_rebooted.tag"
ECHO %DATE% %TIME%[Log TRACE]  shutdown /r /t 10>>%AcerLog%
shutdown /r /t 10
pause
exit /b 0

:TRIM
setlocal enabledelayedexpansion
Call :TRIMSUB %%%1%%
endlocal & set %1=%tempvar%
exit /b 0

:TRIMSUB
Set tempvar=%*
exit /b 0


:ErrorMsg
ECHO %DATE% %TIME%[Log TRACE]  Cscript /nologo ShowErrMsg.vbs %ErrorNum% >>%AcerLog%
Cscript /nologo ShowErrMsg.vbs %ErrorNum%
exit /b 0